import * as i0 from '@angular/core';
import { Injectable } from '@angular/core';

class StorageBase {
    getItem(key) {
        return window.localStorage.getItem(key);
    }
    setItem(key, value) {
        if (!value) {
            window.localStorage.removeItem(key);
        }
        else {
            window.localStorage.setItem(key, value);
        }
    }
    setJsonItem(key, jsonKey, value) {
        let settings = this.getItem(key);
        const json = settings ? JSON.parse(settings) : {};
        json[jsonKey] = value;
        settings = JSON.stringify(json);
        this.setItem(key, settings);
    }
    getJsonItem(key, jsonKey) {
        let settings = this.getItem(key);
        return settings ? JSON.parse(settings)[jsonKey] : null;
    }
}

var NeerStorageKey;
(function (NeerStorageKey) {
    NeerStorageKey["SidebarCollapsed"] = "sidebar";
    NeerStorageKey["Theme"] = "theme";
    NeerStorageKey["SplitSizes"] = "split_settings";
    NeerStorageKey["ColumnSequences"] = "colseq_settings";
})(NeerStorageKey || (NeerStorageKey = {}));

class NeerStorageService extends StorageBase {
    setSplitSizes(key, value) {
        this.setJsonItem(NeerStorageKey.SplitSizes, key, value);
    }
    getSplitSizes(key) {
        return this.getJsonItem(NeerStorageKey.SplitSizes, key);
    }
    setColumnSequence(key, value) {
        this.setJsonItem(NeerStorageKey.ColumnSequences, key, value);
    }
    getColumnSequence(key) {
        return this.getJsonItem(NeerStorageKey.ColumnSequences, key);
    }
    get sidebarCollapsed() {
        const value = this.getItem(NeerStorageKey.SidebarCollapsed);
        return value === 'hide';
    }
    set sidebarCollapsed(value) {
        this.setItem(NeerStorageKey.SidebarCollapsed, value ? 'hide' : 'show');
    }
    get theme() {
        return this.getItem(NeerStorageKey.Theme);
    }
    set theme(value) {
        this.setItem(NeerStorageKey.Theme, value);
    }
}
NeerStorageService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: NeerStorageService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
NeerStorageService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: NeerStorageService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: NeerStorageService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { NeerStorageKey, NeerStorageService, StorageBase };
//# sourceMappingURL=neercms-services-storage.mjs.map
