import * as i0 from '@angular/core';
import { Injectable, EventEmitter } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import * as i1 from '@angular/cdk/layout';

class LoaderService {
    constructor() {
        this.isLoading = new BehaviorSubject(false);
    }
    show() {
        this.isLoading.next(true);
    }
    hide() {
        this.isLoading.next(false);
    }
}
LoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: LoaderService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
LoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: LoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: LoaderService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

class ModalsService {
    constructor() {
        this.current = new BehaviorSubject({});
    }
    showConfirmDelete(handlers) {
        this.showModal(this.deleteModal(), handlers);
    }
    showConfirmBan(modelName, handlers) {
        this.showModal(this.banModal(modelName), handlers);
    }
    showConfirmLiftBan(modelName, handlers) {
        this.showModal(this.liftBanModal(modelName), handlers);
    }
    showConfirmPublish(modelName, handlers) {
        this.showModal(this.publishModal(modelName), handlers);
    }
    showModal(modal, handlers) {
        modal.confirmed = handlers.confirmed;
        modal.closed = handlers.closed;
        this.current.next(modal);
    }
    deleteModal() {
        return {
            title: 'Confirm Delete',
            text: 'Are you sure that you want to delete this?',
            confirmVariant: 'danger',
        };
    }
    banModal(modelName) {
        return {
            title: `Confirm ${modelName} BAN`,
            text: `Are you sure that you want to BAN this ${modelName.toLowerCase()}?`,
            confirmVariant: 'danger',
            confirmText: 'BAN THIS SHIT!',
            showTextArea: true,
        };
    }
    liftBanModal(modelName) {
        return {
            title: `Confirm ${modelName} Lift the BAN`,
            text: `Are you sure that you want to lift the BAN from this ${modelName.toLowerCase()}?`,
            confirmVariant: 'warning',
            confirmText: 'Lift the BAN',
        };
    }
    publishModal(modelName) {
        return {
            title: `Confirm ${modelName} Publish`,
            text: `Are you sure that you want to publish this ${modelName.toLowerCase()}?`,
            confirmVariant: 'success',
            confirmText: 'Confirm and Publish',
        };
    }
}
ModalsService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ModalsService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
ModalsService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ModalsService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ModalsService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }] });

class TitleProviderService {
    constructor() { }
}
TitleProviderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: TitleProviderService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
TitleProviderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: TitleProviderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: TitleProviderService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }], ctorParameters: function () { return []; } });

class ToasterService {
    constructor() {
        this.toasts = [];
        this.index = 0;
        this.toastsArea = document.getElementById('toasts-area');
        // Hate simple for loops
        this.toasts.push(this.createToast());
        this.toasts.push(this.createToast());
        this.toasts.push(this.createToast());
        this.toasts.push(this.createToast());
        this.toasts.push(this.createToast());
        this.toasts.push(this.createToast());
    }
    showSuccess(message, icon) {
        this.show('success', message, icon, 4000);
    }
    showFail(message, icon) {
        this.show('danger', message, icon, 20000);
    }
    showInfo(message, icon) {
        this.show('info', message, icon, 10000);
    }
    show(color, message, icon, lifetime = 5000) {
        const toast = this.getNextToast();
        toast.toast._config.delay = lifetime;
        toast.toast.hide();
        toast.toastElm.dataset['color'] = color;
        toast.toastBodyElm.innerHTML = icon
            ? `<div class="icon"><i class="las la-${icon}"></i></div>${message}`
            : message;
        toast.toast.show();
    }
    getNextToast() {
        if (this.index === this.toasts.length) {
            this.index = 0;
        }
        return this.toasts[this.index++];
    }
    createToast() {
        const toastElm = document.createElement('div');
        toastElm.classList.add('toast');
        toastElm.ariaRoleDescription = 'alert';
        toastElm.ariaLive = 'assertive';
        toastElm.ariaAtomic = 'true';
        const toastBodyElm = document.createElement('div');
        toastBodyElm.classList.add('toast-body');
        toastElm.appendChild(toastBodyElm);
        this.toastsArea.appendChild(toastElm);
        const toast = bootstrap.Toast.getOrCreateInstance(toastElm, {
            animation: false,
            // autohide: false,
            // delay: 5000,
        });
        toastElm.onclick = () => {
            toast.hide();
        };
        return {
            toast: toast,
            toastElm: toastElm,
            toastBodyElm: toastBodyElm,
        };
    }
}
ToasterService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ToasterService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
ToasterService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ToasterService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ToasterService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }], ctorParameters: function () { return []; } });

class ViewportService {
    constructor(media) {
        this.screenSizeChange = new EventEmitter();
        this.mobileQuery = media.matchMedia('(max-width: 640px)');
        this.tabletQuery = media.matchMedia('(max-width: 900px)');
        const self = this;
        this.mobileQuery.addEventListener('change', () => {
            self.screenSizeChange.emit();
        });
    }
    get isMobile() {
        return this.mobileQuery.matches;
    }
    get isTablet() {
        return this.tabletQuery.matches;
    }
    get isDesktop() {
        return !this.tabletQuery.matches;
    }
    addResizeListener(listener) {
        return this.screenSizeChange.subscribe(listener);
    }
    dispose() {
        // this.screenSizeChange.unsubscribe();
    }
}
ViewportService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ViewportService, deps: [{ token: i1.MediaMatcher }], target: i0.ɵɵFactoryTarget.Injectable });
ViewportService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ViewportService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ViewportService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }], ctorParameters: function () { return [{ type: i1.MediaMatcher }]; } });

/**
 * Generated bundle index. Do not edit.
 */

export { LoaderService, ModalsService, TitleProviderService, ToasterService, ViewportService };
//# sourceMappingURL=neercms-services-viewport.mjs.map
