import * as i0 from '@angular/core';
import { EventEmitter, Component, Input, Output, Directive, ViewChild, ContentChildren, NgModule } from '@angular/core';
import * as i1 from 'neercms/services/storage';
import * as i3 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i3$1 from 'neercms/core';
import { CoreComponentsModule } from 'neercms/core';
import * as i1$1 from '@angular/forms';
import { FormGroup, FormControl, ReactiveFormsModule } from '@angular/forms';
import { textOperators, numberOperators, postfixes, defaultTextOperator, defaultNumberOperator, buildFiltersQuery } from 'neercms/table/sieve';
import { DataTableError, FilterType } from 'neercms/table/types';
import { debounceTime, distinctUntilChanged } from 'rxjs';
import * as i1$2 from '@angular/router';
import * as i2$1 from 'neercms/services/viewport';
import * as i2 from 'neercms/services';
import * as i4 from 'neercms/form';
import { FormComponentsModule } from 'neercms/form';
import * as i5 from 'ngx-mask';
import { NgxMaskModule } from 'ngx-mask';

class ColumnChooserComponent {
    constructor(storage) {
        this.storage = storage;
        this.sequence = [];
        this.columnsChange = new EventEmitter();
        this.sequenceChange = new EventEmitter();
    }
    ngOnInit() {
        console.log('cols on init:', this.columns);
    }
    ngOnChanges(changes) {
        if (changes.columns) {
            console.log('cols on change:', this.columns);
            this.updateChooserOptions();
        }
    }
    onOptionChange(column, event) {
        const checkbox = event.target;
        column.hidden = !checkbox.checked;
        if (column.hidden) {
            // Disallow hide last column
            if (this.sequence.length <= 1) {
                checkbox.checked = true;
                column.hidden = false;
            }
            else {
                this.sequence = this.sequence.filter(x => x !== column.key);
                this.sequenceChange.emit(this.sequence);
            }
        }
        else {
            this.sequence.push(column.key);
            this.sequenceChange.emit(this.sequence);
        }
        this.columnsChange.emit(this.columns);
        this.storage.setColumnSequence(this.sequenceName, this.sequence);
    }
    updateChooserOptions() {
        var _a;
        (_a = this.sequence) !== null && _a !== void 0 ? _a : (this.sequence = this.storage.getColumnSequence(this.sequenceName) || []);
        if (this.sequence && this.sequence.length > 0) {
            this.optionColumns = this.columns.filter(x => x.key && x.title);
        }
        else {
            this.sequence = this.columns.filter(x => !x.hidden).map(x => x.key);
            setTimeout(() => this.sequenceChange.emit(this.sequence), 200);
        }
        this.optionColumns = this.columns.filter(x => x.key && x.title);
    }
}
ColumnChooserComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ColumnChooserComponent, deps: [{ token: i1.NeerStorageService }], target: i0.ɵɵFactoryTarget.Component });
ColumnChooserComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.3.0", type: ColumnChooserComponent, selector: "nc-column-chooser", inputs: { columns: "columns", sequenceName: "sequenceName", sequence: "sequence" }, outputs: { columnsChange: "columnsChange", sequenceChange: "sequenceChange" }, usesOnChanges: true, ngImport: i0, template: "<nc-dropdown key=\"column-chooser\"\n             buttonIcon=\"la-columns\"\n             buttonText=\"Columns\">\n  <li *ngFor=\"let col of optionColumns\"\n      class=\"menu-item form-check dropdown-item{{!col.hideable ? ' inactive' : ''}}\"\n      (click)=\"$event.stopPropagation()\">\n    <label class=\"form-check-label\">\n      <input class=\"form-check-input column-chooser-check\"\n             type=\"checkbox\"\n             [disabled]=\"!col.hideable\"\n             [checked]=\"!col.hidden\"\n             (change)=\"onOptionChange(col, $event)\">\n      {{col.title}}\n    </label>\n  </li>\n</nc-dropdown>\n", styles: ["label{width:100%;height:100%;padding:var(--dropdown-item-padding-y) var(--dropdown-item-padding-x) var(--dropdown-item-padding-y) 2.25rem}.dropdown-item{padding:0!important}.dropdown-item.inactive:hover{background-color:inherit;cursor:default}.dropdown-item.inactive>label{color:var(--gray-200);cursor:default}.column-chooser-check{width:1rem;height:1rem}\n"], dependencies: [{ kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: i3$1.DropdownComponent, selector: "nc-dropdown", inputs: ["key", "buttonIcon", "buttonText", "formFit", "disabled"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ColumnChooserComponent, decorators: [{
            type: Component,
            args: [{ selector: 'nc-column-chooser', template: "<nc-dropdown key=\"column-chooser\"\n             buttonIcon=\"la-columns\"\n             buttonText=\"Columns\">\n  <li *ngFor=\"let col of optionColumns\"\n      class=\"menu-item form-check dropdown-item{{!col.hideable ? ' inactive' : ''}}\"\n      (click)=\"$event.stopPropagation()\">\n    <label class=\"form-check-label\">\n      <input class=\"form-check-input column-chooser-check\"\n             type=\"checkbox\"\n             [disabled]=\"!col.hideable\"\n             [checked]=\"!col.hidden\"\n             (change)=\"onOptionChange(col, $event)\">\n      {{col.title}}\n    </label>\n  </li>\n</nc-dropdown>\n", styles: ["label{width:100%;height:100%;padding:var(--dropdown-item-padding-y) var(--dropdown-item-padding-x) var(--dropdown-item-padding-y) 2.25rem}.dropdown-item{padding:0!important}.dropdown-item.inactive:hover{background-color:inherit;cursor:default}.dropdown-item.inactive>label{color:var(--gray-200);cursor:default}.column-chooser-check{width:1rem;height:1rem}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.NeerStorageService }]; }, propDecorators: { columns: [{
                type: Input
            }], sequenceName: [{
                type: Input
            }], sequence: [{
                type: Input
            }], columnsChange: [{
                type: Output
            }], sequenceChange: [{
                type: Output
            }] } });

class ColumnTemplateContext {
}
class ColumnTemplateDirective {
    constructor(templateRef) {
        this.templateRef = templateRef;
    }
    set ncColumnTemplate(templateName) {
        if (!templateName) {
            throw new DataTableError("ncCustomColumn' name must be specified!");
        }
        this.templateName = templateName;
    }
}
ColumnTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ColumnTemplateDirective, deps: [{ token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
ColumnTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.3.0", type: ColumnTemplateDirective, selector: "[ncColumnTemplate]", inputs: { ncColumnTemplate: "ncColumnTemplate" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: ColumnTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ncColumnTemplate]',
                }]
        }], ctorParameters: function () { return [{ type: i0.TemplateRef }]; }, propDecorators: { ncColumnTemplate: [{
                type: Input
            }] } });

class TablePaginationComponent {
    constructor() {
        this.page = 0;
        this.pageSize = 0;
        this.total = 0;
        this.pageChange = new EventEmitter();
        this.items = [];
        this.lastPage = 0;
    }
    ngOnChanges(changes) {
        this.lastPage = Math.ceil(this.total / this.pageSize);
        this.refresh();
    }
    setPage(value) {
        this.page = value;
        this.pageChange.emit(value);
        this.refresh();
    }
    refresh() {
        const nextShowCount = 2;
        const displayCount = nextShowCount * 2 + 1;
        const lastPage = this.lastPage;
        const generateItems = (from, count) => {
            const res = [];
            for (let i = from; i < from + count; i++) {
                res.push(i);
            }
            return res;
        };
        // 1 2 3
        if (lastPage < displayCount + 4) {
            // console.log('case 1: 1 2 3');
            this.items = generateItems(1, lastPage);
        }
        // 1 2 3 4 5 ... 20
        else if (this.page < nextShowCount + 4) {
            // console.log('case 2: 1 2 3 4 5 ... 20');
            this.items = generateItems(1, displayCount + 2);
        }
        // 1 ... 16 17 18 19 20
        else if (this.page > lastPage - displayCount) {
            // console.log('case 3: 1 ... 16 17 18 19 20');
            this.items = generateItems(lastPage - displayCount - 1, displayCount + 2);
        }
        // 1 2 3 4 5 6 7
        else if (this.page - nextShowCount - 2 === 1 && this.page + nextShowCount + 2 === lastPage) {
            // console.log('case 4: 1 2 3 4 5 6 7');
            this.items = generateItems(this.page - nextShowCount - 2, displayCount + 4);
        }
        // 1 ... 7 8 9 10 11 ... 20
        else {
            // console.log('case 5: 1 ... 7 8 9 10 11 ... 20');
            this.items = generateItems(this.page - nextShowCount, displayCount);
        }
    }
}
TablePaginationComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: TablePaginationComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TablePaginationComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.3.0", type: TablePaginationComponent, selector: "nc-pagination", inputs: { page: "page", pageSize: "pageSize", total: "total" }, outputs: { pageChange: "pageChange" }, usesOnChanges: true, ngImport: i0, template: "<nav *ngIf=\"lastPage > 1\">\n  <ul class=\"pagination pagination-sm\">\n    <li *ngIf=\"items.length > 2 && items[0] !== 1\" class=\"page-item\">\n      <a class=\"page-link\" [class.disabled]=\"page === 1\" (click)=\"setPage(1)\">1</a>\n    </li>\n\n    <li *ngIf=\"items.length > 2 && items[0] !== 1\" class=\"page-item\">\n      <span class=\"page-link disabled pagination-sep\">...</span>\n    </li>\n\n    <li class=\"page-item\" *ngFor=\"let item of items\">\n      <span class=\"page-link\" [class.active]=\"item === page\" (click)=\"setPage(item)\">\n        {{item}}\n      </span>\n    </li>\n\n    <li *ngIf=\"items.length && items[items.length - 1] !== lastPage\" class=\"page-item\">\n      <span class=\"page-link disabled pagination-sep\">...</span>\n    </li>\n\n    <li *ngIf=\"items.length && items[items.length - 1] !== lastPage\" class=\"page-item\">\n      <a class=\"page-link\" [class.disabled]=\"page === lastPage\" (click)=\"setPage(lastPage)\">{{lastPage}}</a>\n    </li>\n  </ul>\n</nav>\n", styles: ["@keyframes fadeInDown{0%{opacity:0;transform:translate3d(0,-20px,0)}to{opacity:1;transform:translateZ(0)}}.page-link{--webkit-touch-callout: none;--webkit-user-select: none;--moz-user-select: none;--ms-user-select: none;-webkit-user-select:none;user-select:none;padding-left:.6rem;padding-right:.6rem}.page-link:not(.pagination-sep){cursor:pointer}.page-link:not(.pagination-sep):hover{border-color:var(--gray-400)}.pagination{margin-bottom:0}\n"], dependencies: [{ kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: TablePaginationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'nc-pagination', template: "<nav *ngIf=\"lastPage > 1\">\n  <ul class=\"pagination pagination-sm\">\n    <li *ngIf=\"items.length > 2 && items[0] !== 1\" class=\"page-item\">\n      <a class=\"page-link\" [class.disabled]=\"page === 1\" (click)=\"setPage(1)\">1</a>\n    </li>\n\n    <li *ngIf=\"items.length > 2 && items[0] !== 1\" class=\"page-item\">\n      <span class=\"page-link disabled pagination-sep\">...</span>\n    </li>\n\n    <li class=\"page-item\" *ngFor=\"let item of items\">\n      <span class=\"page-link\" [class.active]=\"item === page\" (click)=\"setPage(item)\">\n        {{item}}\n      </span>\n    </li>\n\n    <li *ngIf=\"items.length && items[items.length - 1] !== lastPage\" class=\"page-item\">\n      <span class=\"page-link disabled pagination-sep\">...</span>\n    </li>\n\n    <li *ngIf=\"items.length && items[items.length - 1] !== lastPage\" class=\"page-item\">\n      <a class=\"page-link\" [class.disabled]=\"page === lastPage\" (click)=\"setPage(lastPage)\">{{lastPage}}</a>\n    </li>\n  </ul>\n</nav>\n", styles: ["@keyframes fadeInDown{0%{opacity:0;transform:translate3d(0,-20px,0)}to{opacity:1;transform:translateZ(0)}}.page-link{--webkit-touch-callout: none;--webkit-user-select: none;--moz-user-select: none;--ms-user-select: none;-webkit-user-select:none;user-select:none;padding-left:.6rem;padding-right:.6rem}.page-link:not(.pagination-sep){cursor:pointer}.page-link:not(.pagination-sep):hover{border-color:var(--gray-400)}.pagination{margin-bottom:0}\n"] }]
        }], propDecorators: { page: [{
                type: Input
            }], pageSize: [{
                type: Input
            }], total: [{
                type: Input
            }], pageChange: [{
                type: Output
            }] } });

class TablePageSizeComponent {
    constructor() {
        this.pageSizeOptions = [10, 25, 50, 100, 500];
        this.pageSize = this.pageSizeOptions[0];
        this.pageSizeChange = new EventEmitter();
    }
    setPageSize(value) {
        this.pageSize = value;
        this.pageSizeChange.emit(value);
    }
}
TablePageSizeComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: TablePageSizeComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
TablePageSizeComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.3.0", type: TablePageSizeComponent, selector: "nc-page-size", inputs: { pageSizeOptions: "pageSizeOptions", pageSize: "pageSize" }, outputs: { pageSizeChange: "pageSizeChange" }, ngImport: i0, template: "<nc-dropdown key=\"tableSize\"\n              [buttonText]=\"pageSize\">\n  <li *ngFor=\"let option of pageSizeOptions\">\n    <button class=\"dropdown-item\"\n            (click)=\"setPageSize(option)\">{{option}}</button>\n  </li>\n</nc-dropdown>\n", styles: [""], dependencies: [{ kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: i3$1.DropdownComponent, selector: "nc-dropdown", inputs: ["key", "buttonIcon", "buttonText", "formFit", "disabled"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: TablePageSizeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'nc-page-size', template: "<nc-dropdown key=\"tableSize\"\n              [buttonText]=\"pageSize\">\n  <li *ngFor=\"let option of pageSizeOptions\">\n    <button class=\"dropdown-item\"\n            (click)=\"setPageSize(option)\">{{option}}</button>\n  </li>\n</nc-dropdown>\n" }]
        }], propDecorators: { pageSizeOptions: [{
                type: Input
            }], pageSize: [{
                type: Input
            }], pageSizeChange: [{
                type: Output
            }] } });

class TableFilterFieldComponent {
    constructor(formGroup, numberInputProcessor) {
        this.formGroup = formGroup;
        this.numberInputProcessor = numberInputProcessor;
        this.valueChange = new EventEmitter();
        this.FilterType = FilterType;
        this.textOperators = textOperators;
        this.numberOperators = numberOperators;
    }
    ngOnInit() {
        if (this.column.filter === FilterType.number || this.column.filter === FilterType.optNumber) {
            const range = this.column.filterValueRange;
            if (range && range.from && range.to && range.from > range.to) {
                throw new DataTableError('Number input max value mast be greater then min value');
            }
        }
        if (!this.column.key) {
            const columnInfo = JSON.stringify(this.column, null, 2);
            throw new DataTableError(`Column 'key' mast be specified for ${columnInfo}`);
        }
        const formControl = this.formGroup.form.get(this.column.key);
        if (!formControl) {
            throw new DataTableError(`Column 'key' mast be a valid form entry name: '${this.column.key}'`);
        }
        this.formControl = formControl;
        if (this.column.filter === FilterType.optText) {
            this.extraFormControl = this.formGroup.form.get(this.column.key + postfixes.textOp);
            setTimeout(() => this.extraFormControl.setValue(defaultTextOperator));
        }
        else if (this.column.filter === FilterType.optNumber) {
            this.extraFormControl = this.formGroup.form.get(this.column.key + postfixes.numOp);
            setTimeout(() => this.extraFormControl.setValue(defaultNumberOperator));
        }
        else if (this.column.filter === FilterType.dateRange) {
            this.extraFormControl = this.formGroup.form.get(this.column.key + postfixes.endPartOp);
        }
    }
    get isNumberInput() {
        return this.column.filter === FilterType.number || this.column.filter === FilterType.optNumber;
    }
    onChange(event) {
        var _a, _b;
        const value = event.target.value;
        if (this.isNumberInput) {
            if (!value) {
                this.formControl.setValue(null);
            }
            else {
                this.formControl.setValue(+value.replace(' ', ''));
                this.numberInputProcessor.clampValue(this.formControl, (_a = this.column.filterValueRange) === null || _a === void 0 ? void 0 : _a.from, (_b = this.column.filterValueRange) === null || _b === void 0 ? void 0 : _b.to);
                event.target.value = this.formControl.value;
            }
        }
        else {
            this.formControl.setValue(value);
        }
    }
    onKeyUp(event) {
        var _a, _b;
        const value = event.target.value || '';
        if (!value) {
            this.formControl.setValue(null);
        }
        else {
            this.formControl.setValue(+value.replace(' ', ''));
        }
        this.numberInputProcessor.onKeyUp(this.formControl, (_a = this.column.filterValueRange) === null || _a === void 0 ? void 0 : _a.from, (_b = this.column.filterValueRange) === null || _b === void 0 ? void 0 : _b.to, event);
    }
}
TableFilterFieldComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: TableFilterFieldComponent, deps: [{ token: i1$1.FormGroupDirective }, { token: i2.NumberInputProcessorService }], target: i0.ɵɵFactoryTarget.Component });
TableFilterFieldComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.3.0", type: TableFilterFieldComponent, selector: "nc-table-filter-field", inputs: { column: "column", value: "value" }, outputs: { valueChange: "valueChange" }, ngImport: i0, template: "<ng-container [ngSwitch]=\"column.filter\">\n  <!-- Plain Text Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.text\">\n    <input class=\"filter-field form-control\"\n           autocomplete=\"off\"\n           [formControl]=\"formControl\"\n           [id]=\"column.key\"\n           [type]=\"column.filter\"/>\n  </div>\n\n  <!-- Text with Options Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.optText\">\n    <input class=\"filter-field form-control\"\n           autocomplete=\"off\"\n           [formControl]=\"formControl\"\n           [id]=\"column.key\"\n           [type]=\"column.filter\"/>\n    <select class=\"form-select filter-select\" [formControl]=\"extraFormControl!\">\n      <option *ngFor=\"let op of textOperators\" [value]=\"op[0]\">\n        {{op[1]}}\n      </option>\n    </select>\n  </div>\n\n  <!-- Plain Number Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.number\">\n    <ng-container *ngTemplateOutlet=\"numberInput\"></ng-container>\n  </div>\n\n  <!-- Number Range Filter -->\n  <!--  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.numberRange\">-->\n  <!--    <ng-container *ngTemplateOutlet=\"numberInput\"></ng-container>-->\n  <!--    <span class=\"filter-sep\">to</span>-->\n  <!--    <ng-container *ngTemplateOutlet=\"numberInput\"></ng-container>-->\n  <!--  </div>-->\n\n  <!-- Number with Options Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.optNumber\">\n    <ng-container *ngTemplateOutlet=\"numberInput\"></ng-container>\n    <select class=\"form-select filter-select\" [formControl]=\"extraFormControl!\">\n      <option *ngFor=\"let op of numberOperators\" [value]=\"op[0]\">\n        {{op[1]}}\n      </option>\n    </select>\n  </div>\n\n  <!-- Date Range Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.dateRange\">\n    <input ncDatePicker\n           [id]=\"column.key\"\n           type=\"text\"\n           class=\"form-control\"\n           [date]=\"formControl\"\n           [dateTo]=\"extraFormControl!\"\n           datePickerMode=\"date-range\"/>\n  </div>\n\n  <!-- Dropdown Menu Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.dropdown\">\n    <select class=\"form-select\" [formControl]=\"formControl!\">\n      <option value=\"\">Not Selected</option>\n      <option *ngFor=\"let opt of column.options!\" [value]=\"opt\">\n        {{opt}}\n      </option>\n    </select>\n  </div>\n\n  <!-- Yes/No Dropdown Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.boolDropdown\">\n    <select class=\"form-select\" [formControl]=\"formControl!\">\n      <option value=\"\">All</option>\n      <option value=\"true\">Yes</option>\n      <option value=\"false\">No</option>\n    </select>\n  </div>\n\n</ng-container>\n\n<ng-template #numberInput>\n  <input [formControl]=\"formControl\"\n         [id]=\"column.key\"\n         type=\"text\"\n         class=\"filter-field form-control\"\n         lang=\"en\"\n         autocomplete=\"off\"\n         [mask]=\"numberInputProcessor.patternToMask(column.numberPattern)\"\n         [allowNegativeNumbers]=\"!column.filterValueRange || column.filterValueRange.from! < 0 || column.filterValueRange.to! < 0\"\n         (input)=\"onChange($event)\"\n         (keyup)=\"onKeyUp($event)\"/>\n</ng-template>\n", styles: [".filter-wrapper{display:flex;flex-direction:row;flex-wrap:nowrap;justify-content:flex-start;margin:.1rem .05rem}.filter-wrapper input,.filter-wrapper select{border:none}.filter-select{width:15%;min-width:50px;padding:.33rem .2rem;text-align:center;border:none}.filter-sep{font-weight:400;padding:.4rem .33rem 0}.form-control{min-width:50px}.filter-select:focus,.filter-field:focus{z-index:100}\n"], dependencies: [{ kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i3.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i3.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i3.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "component", type: i4.DatePickerComponent, selector: "input[ncDatePicker]", inputs: ["date", "dateTo", "datePickerMode"] }, { kind: "directive", type: i1$1.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i1$1.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i1$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$1.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i5.MaskDirective, selector: "input[mask], textarea[mask]", inputs: ["mask", "specialCharacters", "patterns", "prefix", "suffix", "thousandSeparator", "decimalMarker", "dropSpecialCharacters", "hiddenInput", "showMaskTyped", "placeHolderCharacter", "shownMaskExpression", "showTemplate", "clearIfNotMatch", "validation", "separatorLimit", "allowNegativeNumbers", "leadZeroDateTime", "triggerOnMaskChange"], outputs: ["maskFilled"], exportAs: ["mask", "ngxMask"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: TableFilterFieldComponent, decorators: [{
            type: Component,
            args: [{ selector: 'nc-table-filter-field', template: "<ng-container [ngSwitch]=\"column.filter\">\n  <!-- Plain Text Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.text\">\n    <input class=\"filter-field form-control\"\n           autocomplete=\"off\"\n           [formControl]=\"formControl\"\n           [id]=\"column.key\"\n           [type]=\"column.filter\"/>\n  </div>\n\n  <!-- Text with Options Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.optText\">\n    <input class=\"filter-field form-control\"\n           autocomplete=\"off\"\n           [formControl]=\"formControl\"\n           [id]=\"column.key\"\n           [type]=\"column.filter\"/>\n    <select class=\"form-select filter-select\" [formControl]=\"extraFormControl!\">\n      <option *ngFor=\"let op of textOperators\" [value]=\"op[0]\">\n        {{op[1]}}\n      </option>\n    </select>\n  </div>\n\n  <!-- Plain Number Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.number\">\n    <ng-container *ngTemplateOutlet=\"numberInput\"></ng-container>\n  </div>\n\n  <!-- Number Range Filter -->\n  <!--  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.numberRange\">-->\n  <!--    <ng-container *ngTemplateOutlet=\"numberInput\"></ng-container>-->\n  <!--    <span class=\"filter-sep\">to</span>-->\n  <!--    <ng-container *ngTemplateOutlet=\"numberInput\"></ng-container>-->\n  <!--  </div>-->\n\n  <!-- Number with Options Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.optNumber\">\n    <ng-container *ngTemplateOutlet=\"numberInput\"></ng-container>\n    <select class=\"form-select filter-select\" [formControl]=\"extraFormControl!\">\n      <option *ngFor=\"let op of numberOperators\" [value]=\"op[0]\">\n        {{op[1]}}\n      </option>\n    </select>\n  </div>\n\n  <!-- Date Range Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.dateRange\">\n    <input ncDatePicker\n           [id]=\"column.key\"\n           type=\"text\"\n           class=\"form-control\"\n           [date]=\"formControl\"\n           [dateTo]=\"extraFormControl!\"\n           datePickerMode=\"date-range\"/>\n  </div>\n\n  <!-- Dropdown Menu Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.dropdown\">\n    <select class=\"form-select\" [formControl]=\"formControl!\">\n      <option value=\"\">Not Selected</option>\n      <option *ngFor=\"let opt of column.options!\" [value]=\"opt\">\n        {{opt}}\n      </option>\n    </select>\n  </div>\n\n  <!-- Yes/No Dropdown Filter -->\n  <div class=\"filter-wrapper\" *ngSwitchCase=\"FilterType.boolDropdown\">\n    <select class=\"form-select\" [formControl]=\"formControl!\">\n      <option value=\"\">All</option>\n      <option value=\"true\">Yes</option>\n      <option value=\"false\">No</option>\n    </select>\n  </div>\n\n</ng-container>\n\n<ng-template #numberInput>\n  <input [formControl]=\"formControl\"\n         [id]=\"column.key\"\n         type=\"text\"\n         class=\"filter-field form-control\"\n         lang=\"en\"\n         autocomplete=\"off\"\n         [mask]=\"numberInputProcessor.patternToMask(column.numberPattern)\"\n         [allowNegativeNumbers]=\"!column.filterValueRange || column.filterValueRange.from! < 0 || column.filterValueRange.to! < 0\"\n         (input)=\"onChange($event)\"\n         (keyup)=\"onKeyUp($event)\"/>\n</ng-template>\n", styles: [".filter-wrapper{display:flex;flex-direction:row;flex-wrap:nowrap;justify-content:flex-start;margin:.1rem .05rem}.filter-wrapper input,.filter-wrapper select{border:none}.filter-select{width:15%;min-width:50px;padding:.33rem .2rem;text-align:center;border:none}.filter-sep{font-weight:400;padding:.4rem .33rem 0}.form-control{min-width:50px}.filter-select:focus,.filter-field:focus{z-index:100}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.FormGroupDirective }, { type: i2.NumberInputProcessorService }]; }, propDecorators: { column: [{
                type: Input
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }] } });

class DataTableComponent {
    constructor(router, activatedRoute, toaster, storage) {
        this.router = router;
        this.activatedRoute = activatedRoute;
        this.toaster = toaster;
        this.storage = storage;
        this.defaultSorting = 'id';
        this.columns = [];
        this.showFilters = true;
        this.columnChooser = false;
        this.pageSizeOptions = [10, 25, 50, 100, 500];
        this.pageSize = this.pageSizeOptions[0];
        this.sortsAsc = true;
        this.page = 1;
        this.total = 0;
        this.loading = true;
        this.pageIndicatorText = '';
        this.columnSequence = [];
        this.viewReady = false;
    }
    ngOnInit() {
        if (!this.columns || this.columns.length < 1) {
            throw new DataTableError("Param 'columns' must be specified and has at least one element!");
        }
        this.extractSorts(this.defaultSorting);
        this.filtersForm = new FormGroup({});
        if (this.columnChooser) {
            if (!this.columnChooserSequence) {
                throw new DataTableError("Param 'columnChooserSequence' is required when 'columnChooser' enabled.");
            }
            this.columnSequence = this.storage.getColumnSequence(this.columnChooserSequence) || [];
        }
        for (const col of this.columns) {
            col.hidden = col.hideable && !this.columnSequence.includes(col.key);
            if (col.filter) {
                if (col.filter === FilterType.optText) {
                    this.filtersForm.addControl(col.key + postfixes.textOp, new FormControl());
                }
                else if (col.filter === FilterType.optNumber) {
                    this.filtersForm.addControl(col.key + postfixes.numOp, new FormControl());
                }
                else if (col.filter === FilterType.dateRange) {
                    //  || col.filter === FilterType.numberRange
                    this.filtersForm.addControl(col.key + postfixes.endPartOp, new FormControl());
                }
                this.filtersForm.addControl(col.key, new FormControl(''));
            }
        }
        this.loadFromQueryParams();
        this.loadData();
        this.filtersForm.valueChanges
            .pipe(debounceTime(1000))
            .pipe(distinctUntilChanged())
            .subscribe(changes => {
            if (this.loading) {
                return;
            }
            console.log('on changes', changes);
            const newFilters = buildFiltersQuery(this.filtersForm.value);
            if (this.filters !== newFilters) {
                this.filters = newFilters;
                this.resetPagination();
                this.loadData();
            }
        });
    }
    ngAfterViewInit() {
        this.viewReady = true;
    }
    loadData(updatePaginationInfo = false) {
        this.setQueryParams();
        this.loading = true;
        console.debug('[Data fetching]');
        this.onFilter({
            filters: this.filters,
            sorts: this.formattedSorts,
            page: this.page,
            pageSize: this.pageSize,
        }).subscribe({
            next: result => {
                console.debug('Table data:', result.data);
                this.data = result.data;
                if (updatePaginationInfo || result.total !== this.total) {
                    this.total = result.total;
                    const interval = setInterval(() => {
                        if (this.viewReady) {
                            this.pagination.setPage(this.page);
                            this.updatePageIndicatorText();
                            clearInterval(interval);
                        }
                    }, 200);
                }
                setTimeout(() => (this.loading = false), 1200);
            },
            error: error => {
                setTimeout(() => (this.loading = false), 1200);
                this.toaster.showFail(error.message);
                this.resetPagination();
            },
        });
    }
    getCustomColumnByName(templateName) {
        const customColumn = this.customColumnTemplates.find(x => x.templateName === templateName);
        if (!customColumn) {
            throw new DataTableError(`Custom column not found: "${templateName}"`);
        }
        return customColumn;
    }
    // setFiltersToDefault(): void {
    //   for (const filterKey of Object.keys(this.filtersForm.value)) {
    //     if (postfixes.isTextOp(filterKey)) {
    //       this.filtersForm.get(filterKey)!.setValue(defaultTextOperator);
    //     } else if (postfixes.isNumOp(filterKey)) {
    //       this.filtersForm.get(filterKey)!.setValue(defaultNumberOperator);
    //     } else {
    //       this.filtersForm.get(filterKey)!.setValue(null);
    //     }
    //   }
    // }
    changeSorts(key, event) {
        if (this.sorts === key) {
            // Do not reset if Alt key is press
            if (!this.sortsAsc && !event.altKey) {
                this.extractSorts(this.defaultSorting);
            }
            this.sortsAsc = !this.sortsAsc;
        }
        else {
            this.sorts = key;
            // Click -> ASC; Alt+Click -> DESC
            this.sortsAsc = !event.altKey;
        }
        this.loadData();
    }
    extractSorts(sourceSorts) {
        if (sourceSorts && sourceSorts.startsWith('-')) {
            this.sorts = sourceSorts.substring(1);
            this.sortsAsc = false;
        }
        else {
            this.sorts = sourceSorts || 'id';
        }
    }
    changePage(newPage) {
        if (this.page !== newPage) {
            this.page = newPage;
            this.updatePageIndicatorText();
            this.loadData();
        }
    }
    changePageSize(newPageSize) {
        if (this.pageSize !== newPageSize) {
            this.pageSize = newPageSize;
            this.pagination.setPage(1);
            this.loadData(true);
        }
    }
    resetPagination() {
        this.total = 0;
        this.pagination.setPage(1);
        this.updatePageIndicatorText();
    }
    updatePageIndicatorText() {
        const from = this.page * this.pageSize - this.pageSize + 1;
        const to = Math.min(this.page * this.pageSize, this.total);
        if (to === 0) {
            this.pageIndicatorText = 'No Data';
        }
        const total = this.total && this.total > 0 ? ' of ' + this.total : '';
        this.pageIndicatorText = `${from} – ${to} ${total}`;
    }
    get formattedSorts() {
        return this.sorts
            ? this.sortsAsc
                ? this.sorts
                : '-' + this.sorts
            : this.defaultSorting || 'id';
    }
    setQueryParams() {
        // We set the query params with pure JS because
        // when we do the same using the Angular approach,
        // it triggers a component update every time
        const url = new URL(window.location);
        url.searchParams.set('page', this.page.toString());
        url.searchParams.set('limit', this.pageSize.toString());
        url.searchParams.set('sort', this.sorts ? this.formattedSorts : '');
        window.history.pushState(null, '', url.toString());
    }
    loadFromQueryParams() {
        const params = new Proxy(new URLSearchParams(window.location.search), {
            get: (searchParams, prop) => searchParams.get(prop),
        });
        if (params.page && +params.page) {
            this.page = +params.page;
        }
        if (params.limit && +params.limit) {
            this.pageSize = +params.limit;
        }
        if (params.sort) {
            this.extractSorts(params.sort);
        }
        // if (params.filter) {
        //   this.filters = params.filter;
        //   const filters = parseFiltersQuery(params.filter);
        //   for (const filter of filters) {
        //     const baseKey = filter.key.replace(operatorPostfix, '').replace(endPartPostfix, '');
        //     const column = this.columns.find(x => x.key === baseKey);
        //     if (column && column.filter === FilterType.dateRange) {
        //       const date = DateTime.fromISO(filter.val);
        //       if (filter.op === Operator.LessThen) {
        //         this.filtersForm.get(filter.key + endPartPostfix)?.setValue(date);
        //       } else {
        //         this.filtersForm.get(filter.key)?.setValue(date);
        //       }
        //     }
        //
        //     this.filtersForm.get(filter.key)?.setValue(filter.val);
        //     if (filter.op !== Operator.Equals) {
        //       this.filtersForm.get(filter.key + operatorPostfix)?.setValue(filter.op);
        //     }
        //   }
        // }
    }
}
DataTableComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: DataTableComponent, deps: [{ token: i1$2.Router }, { token: i1$2.ActivatedRoute }, { token: i2$1.ToasterService }, { token: i1.NeerStorageService }], target: i0.ɵɵFactoryTarget.Component });
DataTableComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.3.0", type: DataTableComponent, selector: "nc-data-table", inputs: { defaultSorting: "defaultSorting", columns: "columns", showFilters: "showFilters", columnChooser: "columnChooser", columnChooserSequence: "columnChooserSequence", pageSizeOptions: "pageSizeOptions", pageSize: "pageSize", onFilter: "onFilter" }, queries: [{ propertyName: "customColumnTemplates", predicate: ColumnTemplateDirective, descendants: true }], viewQueries: [{ propertyName: "pagination", first: true, predicate: ["pagination"], descendants: true }], ngImport: i0, template: "<!--<pre>{{filtersForm.value | json}}</pre>-->\n\n<ng-content></ng-content>\n\n<table id=\"users-table\"\n       class=\"table table-hover\">\n  <thead>\n  <tr *ngIf=\"columns && columns.length\">\n    <th *ngFor=\"let col of $any(columns)\"\n        [class.hidden]=\"col.hidden\">\n      <button *ngIf=\"col.sortable; else notSortable\"\n              class=\"btn col-header\"\n              [class.sortable]=\"!!col.sortable\"\n              (click)=\"changeSorts(col.key, $event)\">\n        {{col.title}}\n        <i class=\"sort-icon las\"\n           [class.la-arrows-alt-v]=\"sorts !== col.key\"\n           [class.la-arrow-down]=\"sorts === col.key && sortsAsc\"\n           [class.asc]=\"sorts === col.key && sortsAsc\"\n           [class.la-arrow-up]=\"sorts === col.key && !sortsAsc\"\n           [class.desc]=\"sorts === col.key && !sortsAsc\"></i>\n      </button>\n      <ng-template #notSortable>\n        <div class=\"col-header\"\n             [class.col-fullsized]=\"!!col.actions\">\n          {{col.title}}\n        </div>\n      </ng-template>\n    </th>\n    <!--<th *ngIf=\"buttons.length > 0\"-->\n    <!--    class=\"table-buttons\">-->\n    <!--      <button class=\" filters-button btn btn-icon btn-outline-danger\" title=\"Reset filters\">-->\n    <!--        <i class=\"las la-filter\"></i>-->\n    <!--      </button>-->\n    <!--</th>-->\n  </tr>\n  <tr *ngIf=\"showFilters\">\n    <th *ngFor=\"let col of $any(columns)\"\n        [formGroup]=\"filtersForm\"\n        [class.hidden]=\"col.hidden\">\n      <nc-table-filter-field *ngIf=\"col.key && col.filter && col.filter !== 'none'\"\n                             [column]=\"col\"></nc-table-filter-field>\n    </th>\n    <!--<th *ngIf=\"buttons.length > 0\"-->\n    <!--    class=\"table-buttons\">-->\n    <!--  <button class=\"filters-button btn btn-icon btn-outline-danger\"-->\n    <!--          title=\"Reset filters\"-->\n    <!--          (click)=\"setFiltersToDefault()\">-->\n    <!--    <i class=\"las la-times-circle\"></i>-->\n    <!--  </button>-->\n    <!--</th>-->\n  </tr>\n  </thead>\n  <tbody>\n  <!--<tr *ngFor=\"let item of data\">-->\n  <!--  <td *ngFor=\"let col of $any(columns)\"-->\n  <!--      [class.table-buttons]=\"!!col.actions\"-->\n  <!--      [class.table-active]=\"col.key === sorts\"-->\n  <!--      [class.hidden]=\"col.hidden\">-->\n  <!--    <ng-container *ngIf=\"!col.actions; else actionButtonsColumn\">-->\n  <!--      <div [innerHTML]=\"col.formatter ? col.formatter(item[col.key], item) : item[col.key]\"></div>-->\n  <!--    </ng-container>-->\n  <!--    <ng-template #actionButtonsColumn>-->\n  <!--      <button *ngFor=\"let btn of col.actions\"-->\n  <!--              class=\"btn {{btn.button.class}}\"-->\n  <!--              (click)=\"btn.onClick(item)\">-->\n  <!--      <span *ngIf=\"btn.button.text\"-->\n  <!--            class=\"text\">{{btn.button.text}}</span>-->\n  <!--        <i *ngIf=\"btn.button.icon\"-->\n  <!--           class=\"las {{btn.button.icon}}\"></i>-->\n  <!--      </button>-->\n  <!--    </ng-template>-->\n  <!--  </td>-->\n  <!--</tr>-->\n  <tr *ngFor=\"let item of data\">\n    <td *ngFor=\"let col of $any(columns)\"\n        [class.col-fullsized]=\"col.style === 1 || !!col.actions\"\n        [class.table-active]=\"col.key === sorts\"\n        [class.hidden]=\"col.hidden\">\n      <ng-container *ngIf=\"col.template; else formatterColumn\">\n        <ng-container [ngTemplateOutlet]=\"getCustomColumnByName(col.template).templateRef\"\n                      [ngTemplateOutletContext]=\"{value: item[col.key], object: item}\"></ng-container>\n      </ng-container>\n      <ng-template #formatterColumn>\n        <ng-container *ngIf=\"!col.actions; else actionButtonsColumn\">\n          <div [innerHTML]=\"col.formatter ? col.formatter(item[col.key], item) : item[col.key]\"></div>\n        </ng-container>\n        <ng-template #actionButtonsColumn>\n          <button *ngFor=\"let btn of col.actions\"\n                  class=\"btn {{btn.button.class}}\"\n                  (click)=\"btn.onClick(item)\">\n            <span *ngIf=\"btn.button.text\"\n                  class=\"text\">{{btn.button.text}}</span>\n            <i *ngIf=\"btn.button.icon\"\n               class=\"las {{btn.button.icon}}\"></i>\n          </button>\n        </ng-template>\n      </ng-template>\n    </td>\n  </tr>\n  <tr *ngIf=\"data && data.length === 0\">\n    <td class=\"no-data\"\n        [attr.colspan]=\"columns.length\">\n      No data matching \uD83D\uDE14\n    </td>\n  </tr>\n  </tbody>\n</table>\n\n<div class=\"table-footer\"\n     [class.hidden]=\"!data || data.length === 0\">\n\n  <nc-column-chooser *ngIf=\"columnChooser\"\n                     [sequenceName]=\"columnChooserSequence!\"\n                     [(sequence)]=\"columnSequence\"\n                     [(columns)]=\"columns\"></nc-column-chooser>\n\n  <nc-page-size *ngIf=\"data && total > pageSizeOptions[0]\"\n                [pageSize]=\"pageSize\"\n                [pageSizeOptions]=\"pageSizeOptions\"\n                (pageSizeChange)=\"changePageSize($event)\"></nc-page-size>\n\n  <div class=\"page-indicator\">{{pageIndicatorText}}</div>\n\n  <nc-pagination #pagination\n                 [page]=\"page\"\n                 [pageSize]=\"pageSize\"\n                 [total]=\"total\"\n                 (pageChange)=\"changePage($event)\"></nc-pagination>\n</div>\n", styles: [":host{display:block}table{background-color:var(--table-bg)}table,thead{height:100%}th{padding:0}.col-header{position:relative;width:100%;height:100%;padding:.5rem;color:var(--table-header-color);font-weight:700;display:flex;justify-content:space-between;align-items:flex-end;text-align:left;border:none}.col-header.sortable:hover{background-color:var(--table-header-hover-bg)}.col-header.sortable:hover .sort-icon{opacity:100%}.col-header .sort-icon{position:absolute;right:.66rem;top:0;padding:.75rem .15rem;transition:padding .05s ease-in-out;font-size:1rem;opacity:25%}.col-header .sort-icon.asc,.col-header .sort-icon.desc{opacity:100%}thead tr{background-color:var(--table-header-bg)}tr{border-color:var(--gray-400)}tr:hover button{opacity:1}tr:hover .no-data{--table-accent-bg: inherit}tr .no-data{text-align:center;height:8rem;padding-top:3rem}td{white-space:nowrap;vertical-align:middle}.table-footer{height:2rem;margin:2rem 0;display:flex;flex-direction:row;flex-wrap:nowrap;justify-content:flex-end;vertical-align:middle}.table-footer>*{margin-right:2rem}.page-indicator{font-size:.9rem;align-self:center}\n"], dependencies: [{ kind: "directive", type: i3.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i3.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i1$1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i1$1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "component", type: TablePaginationComponent, selector: "nc-pagination", inputs: ["page", "pageSize", "total"], outputs: ["pageChange"] }, { kind: "component", type: TablePageSizeComponent, selector: "nc-page-size", inputs: ["pageSizeOptions", "pageSize"], outputs: ["pageSizeChange"] }, { kind: "component", type: TableFilterFieldComponent, selector: "nc-table-filter-field", inputs: ["column", "value"], outputs: ["valueChange"] }, { kind: "component", type: ColumnChooserComponent, selector: "nc-column-chooser", inputs: ["columns", "sequenceName", "sequence"], outputs: ["columnsChange", "sequenceChange"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: DataTableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'nc-data-table', template: "<!--<pre>{{filtersForm.value | json}}</pre>-->\n\n<ng-content></ng-content>\n\n<table id=\"users-table\"\n       class=\"table table-hover\">\n  <thead>\n  <tr *ngIf=\"columns && columns.length\">\n    <th *ngFor=\"let col of $any(columns)\"\n        [class.hidden]=\"col.hidden\">\n      <button *ngIf=\"col.sortable; else notSortable\"\n              class=\"btn col-header\"\n              [class.sortable]=\"!!col.sortable\"\n              (click)=\"changeSorts(col.key, $event)\">\n        {{col.title}}\n        <i class=\"sort-icon las\"\n           [class.la-arrows-alt-v]=\"sorts !== col.key\"\n           [class.la-arrow-down]=\"sorts === col.key && sortsAsc\"\n           [class.asc]=\"sorts === col.key && sortsAsc\"\n           [class.la-arrow-up]=\"sorts === col.key && !sortsAsc\"\n           [class.desc]=\"sorts === col.key && !sortsAsc\"></i>\n      </button>\n      <ng-template #notSortable>\n        <div class=\"col-header\"\n             [class.col-fullsized]=\"!!col.actions\">\n          {{col.title}}\n        </div>\n      </ng-template>\n    </th>\n    <!--<th *ngIf=\"buttons.length > 0\"-->\n    <!--    class=\"table-buttons\">-->\n    <!--      <button class=\" filters-button btn btn-icon btn-outline-danger\" title=\"Reset filters\">-->\n    <!--        <i class=\"las la-filter\"></i>-->\n    <!--      </button>-->\n    <!--</th>-->\n  </tr>\n  <tr *ngIf=\"showFilters\">\n    <th *ngFor=\"let col of $any(columns)\"\n        [formGroup]=\"filtersForm\"\n        [class.hidden]=\"col.hidden\">\n      <nc-table-filter-field *ngIf=\"col.key && col.filter && col.filter !== 'none'\"\n                             [column]=\"col\"></nc-table-filter-field>\n    </th>\n    <!--<th *ngIf=\"buttons.length > 0\"-->\n    <!--    class=\"table-buttons\">-->\n    <!--  <button class=\"filters-button btn btn-icon btn-outline-danger\"-->\n    <!--          title=\"Reset filters\"-->\n    <!--          (click)=\"setFiltersToDefault()\">-->\n    <!--    <i class=\"las la-times-circle\"></i>-->\n    <!--  </button>-->\n    <!--</th>-->\n  </tr>\n  </thead>\n  <tbody>\n  <!--<tr *ngFor=\"let item of data\">-->\n  <!--  <td *ngFor=\"let col of $any(columns)\"-->\n  <!--      [class.table-buttons]=\"!!col.actions\"-->\n  <!--      [class.table-active]=\"col.key === sorts\"-->\n  <!--      [class.hidden]=\"col.hidden\">-->\n  <!--    <ng-container *ngIf=\"!col.actions; else actionButtonsColumn\">-->\n  <!--      <div [innerHTML]=\"col.formatter ? col.formatter(item[col.key], item) : item[col.key]\"></div>-->\n  <!--    </ng-container>-->\n  <!--    <ng-template #actionButtonsColumn>-->\n  <!--      <button *ngFor=\"let btn of col.actions\"-->\n  <!--              class=\"btn {{btn.button.class}}\"-->\n  <!--              (click)=\"btn.onClick(item)\">-->\n  <!--      <span *ngIf=\"btn.button.text\"-->\n  <!--            class=\"text\">{{btn.button.text}}</span>-->\n  <!--        <i *ngIf=\"btn.button.icon\"-->\n  <!--           class=\"las {{btn.button.icon}}\"></i>-->\n  <!--      </button>-->\n  <!--    </ng-template>-->\n  <!--  </td>-->\n  <!--</tr>-->\n  <tr *ngFor=\"let item of data\">\n    <td *ngFor=\"let col of $any(columns)\"\n        [class.col-fullsized]=\"col.style === 1 || !!col.actions\"\n        [class.table-active]=\"col.key === sorts\"\n        [class.hidden]=\"col.hidden\">\n      <ng-container *ngIf=\"col.template; else formatterColumn\">\n        <ng-container [ngTemplateOutlet]=\"getCustomColumnByName(col.template).templateRef\"\n                      [ngTemplateOutletContext]=\"{value: item[col.key], object: item}\"></ng-container>\n      </ng-container>\n      <ng-template #formatterColumn>\n        <ng-container *ngIf=\"!col.actions; else actionButtonsColumn\">\n          <div [innerHTML]=\"col.formatter ? col.formatter(item[col.key], item) : item[col.key]\"></div>\n        </ng-container>\n        <ng-template #actionButtonsColumn>\n          <button *ngFor=\"let btn of col.actions\"\n                  class=\"btn {{btn.button.class}}\"\n                  (click)=\"btn.onClick(item)\">\n            <span *ngIf=\"btn.button.text\"\n                  class=\"text\">{{btn.button.text}}</span>\n            <i *ngIf=\"btn.button.icon\"\n               class=\"las {{btn.button.icon}}\"></i>\n          </button>\n        </ng-template>\n      </ng-template>\n    </td>\n  </tr>\n  <tr *ngIf=\"data && data.length === 0\">\n    <td class=\"no-data\"\n        [attr.colspan]=\"columns.length\">\n      No data matching \uD83D\uDE14\n    </td>\n  </tr>\n  </tbody>\n</table>\n\n<div class=\"table-footer\"\n     [class.hidden]=\"!data || data.length === 0\">\n\n  <nc-column-chooser *ngIf=\"columnChooser\"\n                     [sequenceName]=\"columnChooserSequence!\"\n                     [(sequence)]=\"columnSequence\"\n                     [(columns)]=\"columns\"></nc-column-chooser>\n\n  <nc-page-size *ngIf=\"data && total > pageSizeOptions[0]\"\n                [pageSize]=\"pageSize\"\n                [pageSizeOptions]=\"pageSizeOptions\"\n                (pageSizeChange)=\"changePageSize($event)\"></nc-page-size>\n\n  <div class=\"page-indicator\">{{pageIndicatorText}}</div>\n\n  <nc-pagination #pagination\n                 [page]=\"page\"\n                 [pageSize]=\"pageSize\"\n                 [total]=\"total\"\n                 (pageChange)=\"changePage($event)\"></nc-pagination>\n</div>\n", styles: [":host{display:block}table{background-color:var(--table-bg)}table,thead{height:100%}th{padding:0}.col-header{position:relative;width:100%;height:100%;padding:.5rem;color:var(--table-header-color);font-weight:700;display:flex;justify-content:space-between;align-items:flex-end;text-align:left;border:none}.col-header.sortable:hover{background-color:var(--table-header-hover-bg)}.col-header.sortable:hover .sort-icon{opacity:100%}.col-header .sort-icon{position:absolute;right:.66rem;top:0;padding:.75rem .15rem;transition:padding .05s ease-in-out;font-size:1rem;opacity:25%}.col-header .sort-icon.asc,.col-header .sort-icon.desc{opacity:100%}thead tr{background-color:var(--table-header-bg)}tr{border-color:var(--gray-400)}tr:hover button{opacity:1}tr:hover .no-data{--table-accent-bg: inherit}tr .no-data{text-align:center;height:8rem;padding-top:3rem}td{white-space:nowrap;vertical-align:middle}.table-footer{height:2rem;margin:2rem 0;display:flex;flex-direction:row;flex-wrap:nowrap;justify-content:flex-end;vertical-align:middle}.table-footer>*{margin-right:2rem}.page-indicator{font-size:.9rem;align-self:center}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$2.Router }, { type: i1$2.ActivatedRoute }, { type: i2$1.ToasterService }, { type: i1.NeerStorageService }]; }, propDecorators: { pagination: [{
                type: ViewChild,
                args: ['pagination']
            }], customColumnTemplates: [{
                type: ContentChildren,
                args: [ColumnTemplateDirective, { descendants: true }]
            }], defaultSorting: [{
                type: Input
            }], columns: [{
                type: Input
            }], showFilters: [{
                type: Input
            }], columnChooser: [{
                type: Input
            }], columnChooserSequence: [{
                type: Input
            }], pageSizeOptions: [{
                type: Input
            }], pageSize: [{
                type: Input
            }], onFilter: [{
                type: Input
            }] } });

class TableComponentsModule {
}
TableComponentsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: TableComponentsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
TableComponentsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.3.0", ngImport: i0, type: TableComponentsModule, declarations: [DataTableComponent,
        TablePaginationComponent,
        TablePageSizeComponent,
        TableFilterFieldComponent,
        ColumnChooserComponent,
        ColumnTemplateDirective], imports: [CommonModule,
        CoreComponentsModule,
        FormComponentsModule,
        ReactiveFormsModule,
        NgxMaskModule], exports: [DataTableComponent, ColumnTemplateDirective] });
TableComponentsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: TableComponentsModule, imports: [CommonModule,
        CoreComponentsModule,
        FormComponentsModule,
        ReactiveFormsModule,
        NgxMaskModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: TableComponentsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DataTableComponent,
                        TablePaginationComponent,
                        TablePageSizeComponent,
                        TableFilterFieldComponent,
                        ColumnChooserComponent,
                        ColumnTemplateDirective,
                    ],
                    exports: [DataTableComponent, ColumnTemplateDirective],
                    imports: [
                        CommonModule,
                        CoreComponentsModule,
                        FormComponentsModule,
                        ReactiveFormsModule,
                        NgxMaskModule,
                    ],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { ColumnChooserComponent, ColumnTemplateDirective, DataTableComponent, TableComponentsModule, TableFilterFieldComponent, TablePageSizeComponent, TablePaginationComponent };
//# sourceMappingURL=neercms-table.mjs.map
