import { color } from 'neercms/shared/types';
export declare type InputType = 'text' | 'password' | 'email' | 'phone';
export declare type Size = 'small' | 'medium' | 'large';
export declare type NumberPattern = 'integer' | 'float' | 'float(2)' | string;
export declare type DateTimeMode = 'date' | 'date-range' | 'date-time' | 'time';
export declare type PickrMode = 'time' | 'single' | 'multiple' | 'range' | undefined;
export declare type FormReady = null | 'ready' | 'loading' | '404';
export declare class FormReadyWrapper {
    private _state;
    get state(): FormReady;
    set state(value: FormReady);
    toString(): FormReady;
    valueOf(): boolean;
}
export declare type FormId<T = number> = 'create' | T;
export interface ISelectOption {
    key: string | number | null;
    title: string;
    icon?: string;
    markerColor?: color | string;
    onSelected?: (option: ISelectOption) => void;
}
export declare class FormError extends Error {
    constructor(message: string);
}
