import { BehaviorSubject } from 'rxjs';
import { IThemeInfo, Themes } from './types';
import * as i0 from "@angular/core";
export declare class ThemeService<TTheme extends string = string> {
    private readonly overlayContainer;
    private readonly darkBrowserTheme;
    private readonly style;
    private readonly document;
    private readonly media;
    private readonly storage;
    private themes?;
    themeChange: BehaviorSubject<TTheme>;
    constructor();
    init(themes: Themes<TTheme>): void;
    private get defaultTheme();
    get currentThemeName(): TTheme;
    get currentTheme(): IThemeInfo;
    refreshTheme(): void;
    setTheme(theme: TTheme): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ThemeService<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ThemeService<any>>;
}
