import { AfterViewInit, OnInit, QueryList } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';
import { NeerStorageService } from 'neercms/services/storage';
import { ToasterService } from 'neercms/services/viewport';
import { ColumnInfo, FetchApiEvent } from 'neercms/table/types';
import { ColumnTemplateDirective } from '../column-template.directive';
import { TablePaginationComponent } from '../pagination/table-pagination.component';
import * as i0 from "@angular/core";
export declare class DataTableComponent<T> implements OnInit, AfterViewInit {
    private readonly router;
    private readonly activatedRoute;
    private readonly toaster;
    private readonly storage;
    pagination: TablePaginationComponent;
    customColumnTemplates: QueryList<ColumnTemplateDirective<T>>;
    defaultSorting: string | null;
    columns: ColumnInfo[];
    showFilters: boolean;
    columnChooser: boolean;
    columnChooserSequence?: string;
    pageSizeOptions: number[];
    pageSize: number;
    onFilter: FetchApiEvent<T>;
    sortsAsc: boolean;
    sorts: string | null;
    page: number;
    total: number;
    data?: any[];
    loading: boolean;
    pageIndicatorText: string;
    columnSequence: string[];
    filtersForm: FormGroup;
    private filters?;
    private viewReady;
    constructor(router: Router, activatedRoute: ActivatedRoute, toaster: ToasterService, storage: NeerStorageService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadData(updatePaginationInfo?: boolean): void;
    getCustomColumnByName(templateName: string): ColumnTemplateDirective<T>;
    changeSorts(key: string, event: MouseEvent): void;
    private extractSorts;
    changePage(newPage: number): void;
    changePageSize(newPageSize: number): void;
    private resetPagination;
    private updatePageIndicatorText;
    private get formattedSorts();
    private setQueryParams;
    private loadFromQueryParams;
    static ɵfac: i0.ɵɵFactoryDeclaration<DataTableComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DataTableComponent<any>, "nc-data-table", never, { "defaultSorting": "defaultSorting"; "columns": "columns"; "showFilters": "showFilters"; "columnChooser": "columnChooser"; "columnChooserSequence": "columnChooserSequence"; "pageSizeOptions": "pageSizeOptions"; "pageSize": "pageSize"; "onFilter": "onFilter"; }, {}, ["customColumnTemplates"], ["*"], false>;
}
