import { EventEmitter, OnInit } from '@angular/core';
import { FormControl, FormGroupDirective } from '@angular/forms';
import { NumberInputProcessorService } from 'neercms/services';
import { ColumnInfo, FilterType } from 'neercms/table/types';
import * as i0 from "@angular/core";
export declare type FilterValue = string | number;
export declare class TableFilterFieldComponent implements OnInit {
    private readonly formGroup;
    readonly numberInputProcessor: NumberInputProcessorService;
    column: ColumnInfo | any;
    value: FilterValue;
    valueChange: EventEmitter<FilterValue>;
    formControl: FormControl;
    extraFormControl?: FormControl;
    FilterType: typeof FilterType;
    textOperators: [import("neercms/table/sieve").Operator, string][];
    numberOperators: [import("neercms/table/sieve").Operator, string][];
    constructor(formGroup: FormGroupDirective, numberInputProcessor: NumberInputProcessorService);
    ngOnInit(): void;
    private get isNumberInput();
    onChange(event: any): void;
    onKeyUp(event: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TableFilterFieldComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TableFilterFieldComponent, "nc-table-filter-field", never, { "column": "column"; "value": "value"; }, { "valueChange": "valueChange"; }, never, never, false>;
}
